# This software is licensed under the GPL, Version 2, June 1991
#
# Copyright (c) 2002 Peter Jentsch <lemuren@web.de>
#
# see LICENSE for details
#

import os
from Globals import package_home, ImageFile
from AccessControl.SecurityInfo import allow_module
import FormulatorLayout
import FormFolder
import Components
import Containers
from Containers import containerClasses
from Components import componentClasses
import dummyZBabelTag 


__doc__ = """ FormulatorLayout Product """
__version__='$Revision: 1.5 $'[11:-2]  

def initialize(context):

    context.registerClass(
        FormFolder.FormFolder,
        constructors=(FormFolder.manage_addFormFolderForm,
                      FormFolder.manage_addFormFolder),
        )

    registerClass(
        FormFolder.FormFolder, 
        FormulatorLayout.FormulatorLayout,
        constructors=(FormulatorLayout.manage_addFormulatorLayoutForm,
                      FormulatorLayout.manage_addFormulatorLayout)
        )

    registerClass(
        FormulatorLayout.FormulatorLayout, Containers.Page,
        constructors=(Containers.manage_addPageForm,
                      Containers.manage_addPage)
        )

    for klass in containerClasses:
        allowed_containers = filter(lambda x, k=klass: x.meta_type in k.selected_meta_types, containerClasses)
        for k in allowed_containers:
            constructors = (getattr(Containers, 'manage_add%sForm' % k.__name__),
                            getattr(Containers, 'manage_add%s' % k.__name__))
            registerClass(klass, k, constructors)
        allowed_components = filter(lambda x, k=klass: x.meta_type in k.selected_meta_types, componentClasses)
        for k in allowed_components:
            constructors = (getattr(Components, 'manage_add%sForm' % k.__name__),
                            getattr(Components, 'manage_add%s' % k.__name__))
            registerClass(klass, k, constructors)

# load all the icons automatically
misc_ = {}
path = os.path.join(package_home(globals()), 'www/')

for file in os.listdir(path):
    if file[-3:] in ['gif', 'png']:
        misc_[file[:-4]] = ImageFile('www/%s' %file, globals())

def registerClass(ContainerClass, ElementClass, constructors=()):
    '''registerClass(ContainerClass, ElementClass, constructors=()) --> Register a new Elementclass; return None'''
    dict = { 'name'   : ElementClass.meta_type,
             'action' : 'manage_addProduct/FormulatorLayout/%s' % constructors[0].__name__ }

    for constructor in constructors:
        setattr(ContainerClass, constructor.__name__, constructor)

    ContainerClass.meta_types = ContainerClass.meta_types + (dict,)
    if not dict['name'] in ContainerClass.selected_meta_types:
        ContainerClass.selected_meta_types = ContainerClass.selected_meta_types + (dict['name'],)

